ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.6 by root, Tue Dec 7 10:40:39 2010 UTC vs.
Revision 1.42 by root, Sun May 1 10:03:29 2011 UTC

2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in
5 5
6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan/ # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9
10MKBUNDLE="$STATICPERL/mkbundle"
11
12# perl build variables 10# perl build variables
13PERL_PREFIX="$STATICPERL/perl" # where the perl gets installed 11MAKE=make
14PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 12PERL_VERSION=5.12.3 # 5.8.9 is also a good choice
13PERL_CC=cc
15PERL_CONFIGURE="" # additional Configure arguments 14PERL_CONFIGURE="" # additional Configure arguments
16PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 15PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
17PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
18 17
19ARCH="$(uname -m)" 18ARCH="$(uname -m)"
20 19
21case "$ARCH" in 20case "$ARCH" in
29 ;; 28 ;;
30esac 29esac
31 30
32# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
33# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
34# -z muldefs is to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
35PERL_LDFLAGS="-Wl,--no-gc-sections -z muldefs" 34#PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
35PERL_LDFLAGS=
36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
37 37
38# some configuration options for modules 38# some configuration options for modules
39export PERL_MM_USE_DEFAULT=1 39PERL_MM_USE_DEFAULT=1
40PERL_MM_OPT="MAN1PODS= MAN3PODS="
40#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 41#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
41export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 42EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
43export PERL_MM_USE_DEFAULT PERL_MM_OPT CORO_INTERFACE EV_EXTRA_DEFS
42 44
43# which extra modules to install by default from CPAN that are 45# which extra modules to install by default from CPAN that are
44# required by mkbundle 46# required by mkbundle
45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 47STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
46 48
47# which extra modules you might want to install 49# which extra modules you might want to install
48EXTRA_MODULES="" 50EXTRA_MODULES=""
49 51
50# overridable functions 52# overridable functions
53preconfigure() { : ; }
54patchconfig() { : ; }
51postconfigure() { : ; } 55postconfigure() { : ; }
52postbuild() { : ; } 56postbuild() { : ; }
53postinstall() { : ; } 57postinstall() { : ; }
54 58
55# now source user config, if any 59# now source user config, if any
60if [ "$STATICPERLRC" ]; then
61 . "$STATICPERLRC"
62else
56[ -r /etc/staticperlrc ] && . /etc/staticperlrc 63 [ -r /etc/staticperlrc ] && . /etc/staticperlrc
57[ -r ~/.staticperlrc ] && . ~/.staticperlrc 64 [ -r ~/.staticperlrc ] && . ~/.staticperlrc
58[ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc" 65 [ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc"
66fi
59 67
60############################################################################# 68#############################################################################
61# support 69# support
70
71PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
72
73unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
74unset PERL_MB_OPT
75LC_ALL=C; export LC_ALL # just to be on the safe side
76
77# prepend PATH - not required by staticperl itself, but might make
78# life easier when working in e.g. "staticperl cpan / look"
79PATH="$PERL_PREFIX/perl/bin:$PATH"
62 80
63# set version in a way that Makefile.PL can extract 81# set version in a way that Makefile.PL can extract
64VERSION=VERSION; eval \ 82VERSION=VERSION; eval \
65$VERSION=0.1 83$VERSION="1.22"
66 84
67BZ2=bz2 85BZ2=bz2
68BZIP2=bzip2 86BZIP2=bzip2
69 87
70fatal() { 88fatal() {
103############################################################################# 121#############################################################################
104# clean 122# clean
105 123
106distclean() { 124distclean() {
107 verblock <<EOF 125 verblock <<EOF
108deleting everything installed by this script 126 deleting everything installed by this script (rm -rf $STATICPERL)
109EOF 127EOF
110 128
111 rm -rf "$STATICPERL" 129 rm -rf "$STATICPERL"
112} 130}
113 131
114############################################################################# 132#############################################################################
115# download/configure/compile/install perl 133# download/configure/compile/install perl
116 134
117clean() { 135clean() {
118 cd "$STATICPERL/src/perl-$PERL_VERSION" 2>/dev/null || return 136 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
137}
119 138
120 rm -f staticstamp.configure 139realclean() {
121 make distclean >/dev/null 2>&1 140 rm -f "$PERL_PREFIX/staticstamp.postinstall"
141 rm -f "$PERL_PREFIX/staticstamp.install"
142 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
122} 143}
123 144
124fetch() { 145fetch() {
125 rcd "$STATICPERL" 146 rcd "$STATICPERL"
126 147
135 verblock <<EOF 156 verblock <<EOF
136downloading perl 157downloading perl
137to manually download perl yourself, place 158to manually download perl yourself, place
138perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 159perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
139trying $URL 160trying $URL
161
162either curl or wget is required for automatic download.
163curl is tried first, then wget.
140EOF 164EOF
141 165
142 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 166 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
167 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
143 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 168 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
144 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
145 || fatal "$URL: unable to download" 169 || fatal "$URL: unable to download"
170 rm -f perl-$PERL_VERSION.tar.$BZ2
146 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 171 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
147 fi 172 fi
148 173
149 verblock <<EOF 174 verblock <<EOF
150unpacking perl 175unpacking perl
151EOF 176EOF
152 177
153 mkdir -p unpack 178 mkdir -p unpack
179 rm -rf unpack/perl-$PERL_VERSION
154 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xpC unpack \ 180 $BZIP2 -d <perl-$PERL_VERSION.tar.$BZ2 | ( cd unpack && tar xf - ) \
155 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 181 || fatal "perl-$PERL_VERSION.tar.$BZ2: error during unpacking"
182 chmod -R u+w unpack/perl-$PERL_VERSION
156 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 183 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
157 rmdir -p unpack 184 rmdir -p unpack
158 fi 185 fi
159} 186}
160 187
161# similar to GNU-sed -i or perl -pi 188# similar to GNU-sed -i or perl -pi
162sedreplace() { 189sedreplace() {
163 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 190 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
191 rm -f "$2"
164 mv "$2~" "$2" 192 mv "$2~" "$2"
193}
194
195configure_failure() {
196 cat <<EOF
197
198
199***
200*** Configure failed - see above for the exact error message(s).
201***
202*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
203*** flags are not supported by your compiler. Less often, this is because
204*** PERL_LIBS either contains a library not available on your system (such as
205*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
206***
207*** You can provide your own flags by creating a ~/.staticperlrc file with
208*** variable assignments. For example (these are the actual values used):
209***
210
211PERL_CC="$PERL_CC"
212PERL_CCFLAGS="$PERL_CCFLAGS"
213PERL_OPTIMIZE="$PERL_OPTIMIZE"
214PERL_LDFLAGS="$PERL_LDFLAGS"
215PERL_LIBS="$PERL_LIBS"
216
217EOF
218 exit 1
165} 219}
166 220
167configure() { 221configure() {
168 fetch 222 fetch
169 223
173 227
174 verblock <<EOF 228 verblock <<EOF
175configuring $STATICPERL/src/perl-$PERL_VERSION 229configuring $STATICPERL/src/perl-$PERL_VERSION
176EOF 230EOF
177 231
178 clean
179
180 rm -f "$PERL_PREFIX/staticstamp.install" 232 rm -f "$PERL_PREFIX/staticstamp.install"
181 233
234 "$MAKE" distclean >/dev/null 2>&1
235
236 sedreplace '/^#define SITELIB/d' config_h.SH
237
182 # I hate them 238 # I hate them for this
183 grep -q -- -fstack-protector Configure && \ 239 grep -q -- -fstack-protector Configure && \
184 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 240 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
241
242 # what did that bloke think
243 grep -q -- usedl=.define hints/darwin.sh && \
244 sedreplace '/^usedl=.define.;$/d' hints/darwin.sh
245
246 preconfigure || fatal "preconfigure hook failed"
185 247
186# trace configure \ 248# trace configure \
187 sh Configure -Duselargefiles \ 249 sh Configure -Duselargefiles \
188 -Uuse64bitint \ 250 -Uuse64bitint \
189 -Dusemymalloc=n \ 251 -Dusemymalloc=n \
190 -Uusedl \ 252 -Uusedl \
191 -Uusethreads \ 253 -Uusethreads \
192 -Uuseithreads \ 254 -Uuseithreads \
193 -Uusemultiplicity \ 255 -Uusemultiplicity \
194 -Duseperlio \
195 -Uusesfio \ 256 -Uusesfio \
196 -Uuseshrplib \ 257 -Uuseshrplib \
258 -Uinstallusrbinperl \
197 -Dcppflags="$PERL_CPPFLAGS" \ 259 -A ccflags=" $PERL_CCFLAGS" \
198 -Dccflags="-g2 -fno-strict-aliasing" \ 260 -Dcc="$PERL_CC" \
199 -Doptimize="$PERL_OPTIMIZE" \ 261 -Doptimize="$PERL_OPTIMIZE" \
200 -Dldflags="$PERL_LDFLAGS" \ 262 -Dldflags="$PERL_LDFLAGS" \
201 -Dlibs="$PERL_LIBS" \ 263 -Dlibs="$PERL_LIBS" \
202 -Dprefix="$PERL_PREFIX" \ 264 -Dprefix="$PERL_PREFIX" \
203 -Dbin="$PERL_PREFIX/bin" \ 265 -Dbin="$PERL_PREFIX/bin" \
204 -Dprivlib="$PERL_PREFIX/lib" \ 266 -Dprivlib="$PERL_PREFIX/lib" \
205 -Darchlib="$PERL_PREFIX/lib" \ 267 -Darchlib="$PERL_PREFIX/lib" \
206 -Uusevendorprefix \ 268 -Uusevendorprefix \
207 -Dsitelib="$PERL_PREFIX/lib" \ 269 -Dsitelib="$PERL_PREFIX/lib" \
208 -Dsitearch="$PERL_PREFIX/lib" \ 270 -Dsitearch="$PERL_PREFIX/lib" \
209 -Usitelibexp \
210 -Uman1dir \ 271 -Uman1dir \
211 -Uman3dir \ 272 -Uman3dir \
212 -Usiteman1dir \ 273 -Usiteman1dir \
213 -Usiteman3dir \ 274 -Usiteman3dir \
214 -Dpager=/usr/bin/less \ 275 -Dpager=/usr/bin/less \
215 -Demail="$EMAIL" \ 276 -Demail="$EMAIL" \
216 -Dcf_email="$EMAIL" \ 277 -Dcf_email="$EMAIL" \
217 -Dcf_by="$EMAIL" \ 278 -Dcf_by="$EMAIL" \
218 $PERL_CONFIGURE \ 279 $PERL_CONFIGURE \
280 -Duseperlio \
219 -dE || fatal "Configure failed" 281 -dE || configure_failure
220 282
221 sedreplace ' 283 sedreplace '
222 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 284 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
223 s/ *-fno-stack-protector */ /g 285 s/ *-fno-stack-protector */ /g
224 ' config.sh 286 ' config.sh
225 287
288 patchconfig || fatal "patchconfig hook failed"
289
226 sh Configure -S || fatal "Configure -S failed" 290 sh Configure -S || fatal "Configure -S failed"
227 291
228 postconfigure || fatal "postconfigure hook failed" 292 postconfigure || fatal "postconfigure hook failed"
229 293
230 touch staticstamp.configure 294 touch staticstamp.configure
295}
296
297write_shellscript() {
298 {
299 echo "#!/bin/sh"
300 echo "STATICPERL=\"$STATICPERL\""
301 echo "PERL_PREFIX=\"$PERL_PREFIX\""
302 echo "MAKE=\"$MAKE\""
303 cat
304 } >"$PERL_PREFIX/bin/$1"
305 chmod 755 "$PERL_PREFIX/bin/$1"
231} 306}
232 307
233build() { 308build() {
234 configure 309 configure
235 310
239building $STATICPERL/src/perl-$PERL_VERSION 314building $STATICPERL/src/perl-$PERL_VERSION
240EOF 315EOF
241 316
242 rm -f "$PERL_PREFIX/staticstamp.install" 317 rm -f "$PERL_PREFIX/staticstamp.install"
243 318
244 make || fatal "make: error while building perl" 319 "$MAKE" || fatal "make: error while building perl"
245 320
246 postbuild || fatal "postbuild hook failed" 321 postbuild || fatal "postbuild hook failed"
247} 322}
248 323
249install() { 324install() {
250 [ -e "$PERL_PREFIX/staticstamp.install" ] && return 325 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
251
252 build 326 build
253 327
254 verblock <<EOF 328 verblock <<EOF
255installing $STATICPERL/src/perl-$PERL_VERSION 329installing $STATICPERL/src/perl-$PERL_VERSION
256to $PERL_PREFIX 330to $PERL_PREFIX
257EOF 331EOF
258 332
259 rm -rf "$PERL_PREFIX" 333 ln -sf "perl/bin/" "$STATICPERL/bin"
260 334 ln -sf "perl/lib/" "$STATICPERL/lib"
335
336 mkdir "$STATICPERL/patched"
337
338 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
339 rm -rf "$PERL_PREFIX" # by this rm -rf
340
261 make install || fatal "make install: error while installing" 341 "$MAKE" install || fatal "make install: error while installing"
262 342
263 rcd "$PERL_PREFIX" 343 rcd "$PERL_PREFIX"
264 344
265 # create a "make install" replacement for CPAN 345 # create a "make install" replacement for CPAN
266 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 346 write_shellscript SP-make-install-make <<'EOF'
267make install UNINST=1 347#CAT make-install-make.sh
268if find blib/arch/auto -type f | grep -q -v .exists; then
269 echo Probably an XS module, rebuilding perl
270 make perl
271 rm -f "$PERL_PREFIX"/bin/perl
272 make -f Makefile.aperl inst_perl
273 make -f Makefile.aperl map_clean
274fi
275EOF 348EOF
276 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
277 349
350 # create a "patch modules" helper
351 write_shellscript SP-patch-postinstall <<'EOF'
352#CAT patch-postinstall.sh
353EOF
354
355 "$PERL_PREFIX/bin/SP-patch-postinstall"
356
278 # trick CPAN into avoiding ~/.cpan completely 357 # help to trick CPAN into avoiding ~/.cpan completely
279 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 358 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
280 359
360 # we call cpan with -MCPAN::MyConfig in this script, which
361 # is strictly unnecssary as we have to patch CPAN anyway,
362 # so consider it "for good measure".
281 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 363 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e '
282 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 364 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
283 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 365 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
284 CPAN::Shell->o (conf => q<init>); 366 CPAN::Shell->o (conf => q<init>);
285 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 367 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
286 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 368 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
287 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 369 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
288 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 370 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
289 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 371 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
290 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 372 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/SP-make-install-make");
291 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 373 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
292 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 374 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
375 CPAN::Shell->o (conf => q<prefer_installer>, "EUMM");
293 CPAN::Shell->o (conf => q<commit>); 376 CPAN::Shell->o (conf => q<commit>);
294 ' || fatal "error while initialising CPAN" 377 ' || fatal "error while initialising CPAN"
295 378
379 touch "$PERL_PREFIX/staticstamp.install"
380 fi
381
382 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
296 NOCHECK_INSTALL=+ 383 NOCHECK_INSTALL=+
297 instcpan $STATICPERL_MODULES 384 instcpan $STATICPERL_MODULES
298 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES 385 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES
299 386
300 postinstall || fatal "postinstall hook failed" 387 postinstall || fatal "postinstall hook failed"
301 388
302 touch "$PERL_PREFIX/staticstamp.install" 389 touch "$PERL_PREFIX/staticstamp.postinstall"
390 fi
303} 391}
304 392
305############################################################################# 393#############################################################################
306# install a module from CPAN 394# install a module from CPAN
307 395
312installing modules from CPAN 400installing modules from CPAN
313$@ 401$@
314EOF 402EOF
315 403
316 for mod in "$@"; do 404 for mod in "$@"; do
317 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 405 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e 'notest install => "'"$mod"'"' \
318 || fatal "$mod: unable to install from CPAN" 406 || fatal "$mod: unable to install from CPAN"
319 done 407 done
320 rm -rf "$STATICPERL/build" 408 rm -rf "$STATICPERL/build"
321} 409}
322 410
334 for mod in "$@"; do 422 for mod in "$@"; do
335 echo 423 echo
336 echo $mod 424 echo $mod
337 ( 425 (
338 rcd $mod 426 rcd $mod
339 make -f Makefile.aperl map_clean >/dev/null 2>&1 427 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
340 make distclean >/dev/null 2>&1 428 "$MAKE" distclean >/dev/null 2>&1
341 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 429 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
342 make || fatal "$mod: error building module" 430 "$MAKE" || fatal "$mod: error building module"
343 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 431 "$PERL_PREFIX"/bin/SP-make-install-make install || fatal "$mod: error installing module"
344 make distclean >/dev/null 2>&1 432 "$MAKE" distclean >/dev/null 2>&1
345 exit 0 433 exit 0
346 ) || exit $? 434 ) || exit $?
347 done 435 done
348} 436}
349 437
350############################################################################# 438#############################################################################
351# main 439# main
352 440
353podusage() { 441podusage() {
354 echo 442 echo
443
355 if [ -e "$PERL_PREFIX/bin/perl" ]; then 444 if [ -e "$PERL_PREFIX/bin/perl" ]; then
356 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \ 445 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
357 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 446 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
358 2>/dev/null && exit 447 2>/dev/null && exit
359 fi 448 fi
449
360 # try whatever perl we can find 450 # try whatever perl we can find
361 perl -MPod::Usage -e \ 451 perl -MPod::Usage -e \
362 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 452 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
363 2>/dev/null && exit 453 2>/dev/null && exit
364 454
365 fatal "displaying documentation requires a working perl - try '$0 install' first" 455 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
366} 456}
367 457
368usage() { 458usage() {
369 podusage 0 459 podusage 0
370} 460}
378#CAT mkbundle 468#CAT mkbundle
379MKBUNDLE 469MKBUNDLE
380} 470}
381 471
382bundle() { 472bundle() {
473 MKBUNDLE="${MKBUNDLE:=$PERL_PREFIX/bin/SP-mkbundle}"
383 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 474 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
384 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 475 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
476 CACHE="$STATICPERL/cache"
477 mkdir -p "$CACHE"
385 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" "$@" 478 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
386} 479}
387 480
388if [ $# -gt 0 ]; then 481if [ $# -gt 0 ]; then
389 while [ $# -gt 0 ]; do 482 while [ $# -gt 0 ]; do
390 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create" 483 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create"
391 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create" 484 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create"
392 485
393 command="${1#--}"; shift 486 command="${1#--}"; shift
394 case "$command" in 487 case "$command" in
488 version )
489 echo "staticperl version $VERSION"
490 ;;
395 fetch | configure | build | install | clean | distclean) 491 fetch | configure | build | install | clean | realclean | distclean)
396 verblock <<EOF
397$command
398EOF
399 ( "$command" ) 492 ( "$command" ) || exit
400 ;; 493 ;;
401 instsrc ) 494 instsrc )
402 ( instsrc "$@" ) 495 ( instsrc "$@" ) || exit
403 exit 496 exit
404 ;; 497 ;;
405 instcpan ) 498 instcpan )
406 ( instcpan "$@" ) 499 ( instcpan "$@" ) || exit
500 exit
501 ;;
502 perl )
503 ( install ) || exit
504 exec "$PERL_PREFIX/bin/perl" "$@"
407 exit 505 exit
408 ;; 506 ;;
409 cpan ) 507 cpan )
410 ( install ) 508 ( install ) || exit
411 "$PERL_PREFIX/bin/cpan" "$@" 509 exec "$PERL_PREFIX/bin/cpan" "$@"
412 exit 510 exit
413 ;; 511 ;;
414 mkbundle ) 512 mkbundle )
415 ( install ) 513 ( install ) || exit
416 bundle "$@" 514 bundle "$@"
417 exit 515 exit
418 ;; 516 ;;
419 mkperl ) 517 mkperl )
420 ( install ) 518 ( install ) || exit
421 bundle --perl "$@" 519 bundle --perl "$@"
520 exit
521 ;;
522 mkapp )
523 ( install ) || exit
524 bundle --app "$@"
422 exit 525 exit
423 ;; 526 ;;
424 help ) 527 help )
425 podusage 2 528 podusage 2
426 ;; 529 ;;

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines